if ENABLE_VALA

bin_PROGRAMS =

AM_CFLAGS = \
	-I$(top_srcdir)/src \
	-I$(top_srcdir)/ayyi \
	-I$(top_srcdir)/libs \
	@PACKAGE_CFLAGS@ \
	$(LIBRSVG_INCLUDES) \
	$(FREETYPE_CFLAGS) \
	$(DBUS_CFLAGS) $(CANVAS_CFLAGS)

BUILT_SOURCES = am_controller.vala am_collection.vala am_vala_utils.vala

packages=--pkg gdk-2.0 --pkg glib-2.0 --pkg gtk+-2.0 --pkg dbus-glib-1 --pkg ayyi --pkg model --pkg debug
vapidirs=--vapidir=../../ayyi --vapidir=../vapi --vapidir=../../lib/debug

all: $(BUILT_SOURCES)
	@if [ ! -e "am_controller.c" ]; then \
		make am_controller.c; \
	fi
	@if [ -e "../am_vala_utils.c" ]; then \
		if [ "am_vala_utils.vala" -nt "../am_vala_utils.c" ]; then \
			rm "../am_vala_utils.c"; \
		else echo "am_vala_utils is up to date"; \
		fi; \
	else echo "doesnt exist"; \
	fi;
	make am_vala_utils.vala
	$(MAKE) $(AM_MAKEFLAGS) all-am

am_controller.c: am_controller.vala Makefile ../vapi/model.vapi
	@echo ""
	@echo "am_controller.vala"
	@echo "------------------"
	@if [ ! -s "am_controller.c" ] || [ "../vapi/model.vapi" -nt "am_controller.c" ] || [ "../../ayyi/ayyi.vapi" -nt "am_controller.c" ] || [ Makefile -nt "am_controller.c" ]; then \
		valac -H am_controller.h -C --basedir $(top_srcdir) $(packages) --pkg am_collection $(vapidirs) --vapi=../vapi/am_controller.vapi am_controller.vala 2>&1; \
		sed -i -e 's/_ClientController Cl/_ClientControllerX /' am_controller.c; \
		sed -i -e 's/_ClientControllerClass Cl/_ClientControllerX /' am_controller.c; \
		sed -i -e 's/_ClientControllerClass Cl/_ClientControllerX /' am_controller.c; \
		sed -i -e 's/_ClientControllerPrivate Cl/_ClientControllerX /' am_controller.c; \
		sed -i -e 's/_ClientController {/_ClientControllerX {/' am_controller.c; \
		sed -i -e 's/_ClientControllerClass {/_ClientControllerClassX {/' am_controller.c; \
	else echo "not compiling vala file"; \
	fi;

am_collection.vala: Makefile
	@echo ""
	@echo "am_collection.vala"
	@echo "------------------"
	valac -H am_collection.h -C --basedir $(top_srcdir) $(packages) $(vapidirs) --vapi=../vapi/am_collection.vapi am_collection.vala 2>&1
	@sed  -i -e '/typedef struct _AMArray AMArray/d' am_collection.c
	@sed  -i -e '/typedef struct _AMArray AMArray/d' am_collection.h
	@sed  -i -e '/typedef struct _AMArrayPrivate AMArrayPrivate/d' am_collection.c
	@sed  -i -e '/typedef struct _AMArrayClass AMArrayClass/d' am_collection.c
	@sed  -i -e '/typedef struct _AMList AMList/d' am_collection.c
	@sed  -i -e '/typedef struct _AMList AMList/d' am_collection.h
	@sed  -i -e '/typedef struct _AMListClass AMListClass/d' am_collection.c
	@sed  -i -e '/typedef struct _AMListPrivate AMListPrivate/d' am_collection.c
	@sed  -i -e '/typedef struct _AMTrackList AMTrackList/d' am_collection.h
	@sed  -i -e '/typedef struct _AMTrackList AMTrackList/d' am_collection.c
	@sed  -i -e '/typedef struct _AMTrackListClass AMTrackListClass/d' am_collection.c
	@sed  -i -e '/typedef struct _AMTrackListPrivate AMTrackListPrivate/d' am_collection.c
	@sed  -i -e '/typedef gboolean (\*AMTrackListTrackEach)/d' am_collection.c
	@sed  -i -e '/typedef struct _Model/d' am_collection.c
	@sed  -i -e '/typedef gboolean (\*FilterIteratoraccept)/d' am_collection.c
	@sed  -i -e '/typedef gboolean (\*Filter)/d' am_collection.c
	@sed  -i -e '/typedef gboolean (\*Filter)/d' am_collection.h
	@sed  -i -e '/typedef struct _FilterIterator FilterIterator/d' am_collection.h
	@sed  -i -e '/typedef struct _FilterIterator FilterIterator/d' am_collection.c
	@sed  -i -e '/typedef struct _FilterIteratorAA/d' am_collection.h
	@sed  -i -e '/typedef struct _FilterIterator/d' am_collection.c
	@sed  -i -e 's/struct _ModelCollection {/struct _XModelCollection {/' am_collection.c
	@sed  -i -e 's/struct _ModelCollectionClass {/struct _XModelCollectionClass {/' am_collection.c
	@sed  -i -e 's/struct _AMArray {/struct _XAMArray {/' am_collection.c
	@sed  -i -e 's/struct _AMArrayClass {/struct _XAMArrayClass {/' am_collection.c
	@sed  -i -e 's/struct _AMList {/struct _XAMList {/' am_collection.c
	@sed  -i -e 's/struct _AMListClass {/struct _XAMListClass {/' am_collection.c
	@sed  -i -e 's/struct _AMTrackList {/struct _XAMTrackList {/' am_collection.c
	@sed  -i -e 's/struct _AMTrackListClass {/struct _XAMTrackListClass {/' am_collection.c
	@sed  -i -e 's/struct _FilterIterator {/struct _XFilterIterator {/' am_collection.c
	@sed  -i -e 's/struct _FilterIteratorClass {/struct _XFilterIteratorClass {/' am_collection.c

am_vala_utils.vala: Makefile
	@echo ""
	@echo "am_vala_utils.vala"
	@echo "------------------"
	@if [ ! -e "am_vala_utils.c" ] || [ "am_vala_utils.vala" -nt "am_vala_utils.c" ]; then \
		valac -H am_vala_utils.h -C --basedir $(top_srcdir) $(packages) --pkg am_collection $(vapidirs) --vapi=../vapi/am_vala_utils.vapi am_vala_utils.vala 2>&1; \
	fi;

pool_item.c: Makefile
	valac -H pool_item.h -C --basedir $(top_srcdir) $(vapidirs) --vapi=../../libs/waveform/vala/waveform.vapi --gir=PoolItem-1.0.gir --library=PoolItem-1.0 pool_item.vala

part_input.c: Makefile part_input.vala
	valac -H part_input.h -C --basedir ../.. --vapidir=../vapi --vapidir=../../ayyi --vapidir=../../lib/debug --pkg ayyi --gir=PartInput-1.0.gir --library=PartInput-1.0 part_input.vala

endif
